Bug 1822509 - Review Request: lavalauncher - a simple launcher for Wayland
Summary: Review Request: lavalauncher - a simple launcher for Wayland
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Lyes Saadi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-04-09 08:34 UTC by Bob Hepple
Modified: 2020-05-16 03:39 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-16 03:10:43 UTC
Type: ---
Embargoed:
fedora: fedora-review+


Attachments (Terms of Use)

Description Bob Hepple 2020-04-09 08:34:23 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/wef/lavalauncher/fedora-31-x86_64/01332066-lavalauncher/lavalauncher.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/lavalauncher/fedora-31-x86_64/01332066-lavalauncher/lavalauncher-1.6-4.fc31.src.rpm

Description:
LavaLauncher is a simple launcher for Wayland.

It serves a single purpose: Letting the user execute shell commands by
clicking on icons on a dynamically sized bar, placed at one of the
screen edges or in the center.

Unlike most popular launchers, LavaLauncher does not care about
.desktop files or icon themes. To create a button, you simply provide
the path to an image and a shell command. This makes LavaLauncher
considerably more flexible: You could have buttons not just for
launching applications, but also for ejecting your optical drive,
rotating your screen, sending your cat an email, playing a funny
sound, muting all audio, toggling your lamps, etc. You can turn
practically anything you could do in your shell into a button.

The configuration is done entirely via command flags. See the manpage
for details and an example.

LavaLauncher has been successfully tested with sway and wayfire.

Fedora Account System Username: wef

Comment 1 Lyes Saadi 2020-05-06 00:52:13 UTC
Hi Bob!

Yes, I also think about reviewing this package :P!

But I stumbled upon a weird rule (Yes! Another time :P!):

> If a package contains a GUI application, then it needs to also include a
> properly installed .desktop file. For the purposes of these guidelines, a GUI
> application is defined as any application which draws an X window and runs
> from within that window.

(Yes it says X window, but I imagine it also applies to a Wayland window :P)

I am a bit confused by this and I shouldn't think a desktop file should be added... for the obvious reason that lavalauncher needs arguments to be passed so it works.

So I got back to the beginnings of the Guidelines:

> The Packaging Guidelines are a collection of common issues and the severity
> that should be placed on them. While these guidelines should not be ignored,
> they should also not be blindly followed. If you think that your package should
> be exempt from part of the Guidelines, please bring the issue to the Fedora
> Packaging Committee[1].

> Where the language "must", "is required to" or "needs to" is used, the packager
> may deviate from the guideline only with approval from the packaging committee.
> Please follow the procedure at the Packaging Committee[2] page for making these
> requests.

[1]: https://pagure.io/packaging-committee
[2]: https://fedoraproject.org/wiki/Packaging_Committee#Bringing_Issues_to_the_Committee

So, what do you think?

Comment 2 Lyes Saadi 2020-05-06 02:01:35 UTC
Wait!

After more reading, that is actually not needed, sorry for the error, a comment is enough:

> MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

The Guidelines could have been clearer on that.

Sorry again, I will procede to the review as soon as I finish the form :)!

Comment 3 Bob Hepple 2020-05-06 02:21:12 UTC
Hi Lyes,

I agree, there is no point having a .desktop file as it relies completely on command line options to operate eg

   lavalauncher -b /usr/share/icons/hicolor/scalable/apps/org.gnome.Terminal.svg gnome-terminal -b ...

We could _force_ it to use a .desktop file like xfce4-appfinder's with something like this:

[Desktop Entry]
Version=1.0
Exec=lavalauncher-wrapper
StartupNotify=true
Terminal=false
Type=Application
Categories=Utility;
Name=Application Finder

and script up lavalauncher-wrapper to look for configurations in the first of:

~/.config/lavalauncher/config
/etc/lavalauncher/config

with the latter provided by the package then run it with 

lavalauncher $(cat $CONFIG_FILE)

... at least it would avoid going to the committee.

But honestly, I have no idea what to put in the /etc config file to be universally useful and I think it's properly against the point of lavalauncher. And just because I _can_ do that does not mean that I _should_ do it!!!

There are precedents for this - eg rofi and wofi etc are GUI applications (also application launchers) but do not have .desktop files. zenity too.

On balance, I agree with you and I definitely do not want to put a desktop file in there.

Comment 4 Lyes Saadi 2020-05-06 02:25:16 UTC
Hi, Bob!

Read my last comment, it was an error on my part, sorry again for that -_-'! fedora-review had a misleading entry, and I didn't check enough before sending the comment...

Comment 5 Lyes Saadi 2020-05-06 02:27:10 UTC
Package approved, on the first try! Sorry again for my error...

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- Please add a comment explaining why there shouldn't be a desktop file.
- 1.7.0 is released.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "NTP License (legal disclaimer)", "GPL
     (v3)". 8 files have unknown license. Detailed output of licensecheck
     in /home/lyes/Documents/reviews/1822509-lavalauncher/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
     Note: Should not in this case. Please add a comment explaining why.
     Note: This entry is also misleading -_-'.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
     Note: 1.7.0 released.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: lavalauncher-1.6-4.fc33.x86_64.rpm
          lavalauncher-debuginfo-1.6-4.fc33.x86_64.rpm
          lavalauncher-debugsource-1.6-4.fc33.x86_64.rpm
          lavalauncher-1.6-4.fc33.src.rpm
lavalauncher.x86_64: W: summary-not-capitalized C lavalauncher is a simple launcher for Wayland
lavalauncher.x86_64: W: name-repeated-in-summary C lavalauncher
lavalauncher.x86_64: W: spelling-error %description -l en_US manpage -> manage, man page, man-page
lavalauncher.x86_64: W: spelling-error %description -l en_US wayfire -> way fire, way-fire, wayfarer
lavalauncher.src: W: summary-not-capitalized C lavalauncher is a simple launcher for Wayland
lavalauncher.src: W: name-repeated-in-summary C lavalauncher
lavalauncher.src: W: spelling-error %description -l en_US manpage -> manage, man page, man-page
lavalauncher.src: W: spelling-error %description -l en_US wayfire -> way fire, way-fire, wayfarer
lavalauncher.src:44: W: setup-not-quiet
4 packages and 0 specfiles checked; 0 errors, 9 warnings.




Rpmlint (debuginfo)
-------------------
Checking: lavalauncher-debuginfo-1.6-4.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
lavalauncher-debugsource.x86_64: W: invalid-url URL: https://git.sr.ht/~leon_plickat/lavalauncher <urlopen error [Errno -2] Name or service not known>
lavalauncher-debuginfo.x86_64: W: invalid-url URL: https://git.sr.ht/~leon_plickat/lavalauncher <urlopen error [Errno -2] Name or service not known>
lavalauncher.x86_64: W: summary-not-capitalized C lavalauncher is a simple launcher for Wayland
lavalauncher.x86_64: W: name-repeated-in-summary C lavalauncher
lavalauncher.x86_64: W: spelling-error %description -l en_US manpage -> manage, man page, man-page
lavalauncher.x86_64: W: spelling-error %description -l en_US wayfire -> way fire, way-fire, wayfarer
lavalauncher.x86_64: W: invalid-url URL: https://git.sr.ht/~leon_plickat/lavalauncher <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 0 errors, 7 warnings.

Comment 6 Bob Hepple 2020-05-06 22:09:56 UTC
Thanks again Lyes!

Let's see if the notifier works this time!

Comment 7 Lyes Saadi 2020-05-07 00:17:26 UTC
The notifier worked :P!

Comment 8 Gwyn Ciesla 2020-05-07 13:27:23 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/lavalauncher

Comment 9 Fedora Update System 2020-05-07 21:58:58 UTC
FEDORA-2020-096560024d has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-096560024d

Comment 10 Fedora Update System 2020-05-07 22:34:27 UTC
FEDORA-2020-436a359c2c has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-436a359c2c

Comment 11 Fedora Update System 2020-05-08 04:10:22 UTC
FEDORA-2020-436a359c2c has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-436a359c2c \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-436a359c2c

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2020-05-08 05:09:04 UTC
FEDORA-2020-096560024d has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-096560024d \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-096560024d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2020-05-16 03:10:43 UTC
FEDORA-2020-096560024d has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 14 Fedora Update System 2020-05-16 03:39:13 UTC
FEDORA-2020-436a359c2c has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.